<?php

$merchant = $_GET["merchant"];
$quantity = $_GET["quantity"];
$shippingf = $_GET["shippingf"];
$currency = $_GET["currency"];
$firstname = $_GET["first_name"];
$last_name = $_GET["last_name"];
$email = $_GET["email"];
$amountf = $_GET["amountf"];
$taxf = $_GET["taxf"];
$want_shipping = $_GET["want_shipping"];
$item_name = $_GET["item_name"];
$success_url = $_GET["success_url"];
$cancel_url = $_GET["cancel_url"];
$invoice = $_GET["invoice"];
$ipn_url = $_GET["ipn_url"];
$custom = $_GET["custom"];
$cmd = $_GET["cmd"];
$address1 = $_GET["shippingaddress"];
$city = $_GET["shippingcity"];
$country = $_GET["shippingcountry"];
$zipcode = $_GET['shippingzipcode'];
$phone = $_GET["shippingtelephone"];
$gateway = $_GET['gateway'];
$debug_email = $_GET["debug_email"];
$products = unserialize($_GET['items']);

if(isset($_GET) && !empty($_GET)):
?>
    <html><head><style></style></head><body>
    <form id="form" action="<?php echo $gateway;?>" method="post">
        <input type="hidden" name="cmd" value="<?php echo $cmd;?>">
        <input type="hidden" name="reset" value="1">
        <input type="hidden" name="merchant" value="<?php echo $merchant;?>">
        <input type="hidden" name="item_name" value="<?php echo $item_name;?>">
        <input type="hidden" name="invoice" value="<?php echo $invoice;?>">
        <input type="hidden" name="custom" value="3">
        <input type="hidden" name="quantity" value="<?php echo $quantity;?>">
        <input type="hidden" name="allow_quantity" value="0">
        <input type="hidden" name="want_shipping" value="<?php echo $want_shipping;?>">
        <?php $i = 1; foreach($products as $product): ?>
            <input type="hidden" name="productname<?php echo $i;?>" value="<?php echo $product["name"];?>">
            <input type="hidden" name="productprice<?php echo $i;?>" value="<?php echo $product["price"];?>">
            <input type="hidden" name="productsku<?php echo $i;?>" value="<?php echo $product["sku"];?>">
            <input type="hidden" name="productqty<?php echo $i;?>" value="<?php echo $product["qty"];?>">
            <?php $i++; endforeach;?>
        <input type="hidden" name="shippingfirstname" value="<?php echo $firstname;?>">
        <input type="hidden" name="shippinglastname" value="<?php echo $last_name;?>">
        <input type="hidden" name="shippingaddress" value="<?php echo $address1;?>">
        <input type="hidden" name="shippingcity" value="<?php echo $city;?>">
        <input type="hidden" name="shippingcountry" value="<?php echo $country;?>">
        <input type="hidden" name="shippingzipcode" value="<?php echo $zipcode;?>">
        <input type="hidden" name="shippingtelephone" value="<?php echo $phone;?>">
        <input type="hidden" name="shippingstate" value="">
        <input type="hidden" name="shippingstatecode" value="">
        <input type="hidden" name="currency" value="<?php echo $currency;?>">
        <input type="hidden" name="shippingf" value="<?php echo $shippingf;?>">
        <input type="hidden" name="taxf" value="0.00">
        <input type="hidden" name="amountf" value="<?php echo $amountf;?>">
        <input type="hidden" name="success_url" value="<?php echo $success_url;?>">
        <input type="hidden" name="cancel_url" value="<?php echo $cancel_url;?>">
        <input type="hidden" name="ipn_url" value="<?php echo $ipn_url;?>">
        <input type="hidden" name="email" value="<?php echo $email;?>">
        <input type="hidden" name="first_name" value="<?php echo $firstname;?>">
        <input type="hidden" name="last_name" value="<?php echo $last_name;?>">
    </form>
    <script>document.getElementById("form").submit();</script>
    </body></html>
<?php
endif;

class Process_IPN {

    function __construct($postdata, $debug_email, $merchant){
          $this->debug_email = $debug_email;
          $this->postdata = $postdata;
          $this->merchant = $merchant;
          $this->order_id = $postdata['invoice'];
    }

    function _errorAndDie($error_msg)
    {
        if (!empty($this->debug_email)) {
            $report = "Error Message: " . $error_msg . "\n\n";

            $report .= "AUTH User: " . $_SERVER['PHP_AUTH_USER'] . "\n";
            $report .= "AUTH Pass: " . $_SERVER['PHP_AUTH_PW'] . "\n\n";

            $report .= "POST Fields\n\n";
            foreach ($this->postdata as $key => $value) {
                $report .= $key . '=' . html_entity_decode($value, ENT_QUOTES, 'UTF-8') . "\n";
            }

            mail($this->debug_email, "Coin Payments Invalid IPN", $report);
        }
        die('IPN Error: ' . $error_msg);
    }


    function check_ipn_request_is_valid($ipn){

        if (!isset($ipn['ipn_mode'])) {
            $this->_errorAndDie('IPN received with no ipn_mode.');
        }
        if ($ipn['ipn_mode'] == 'hmac') {
            if (!isset($_SERVER['HTTP_HMAC']) || empty($_SERVER['HTTP_HMAC'])) {
                $this->_errorAndDie('No HMAC signature sent.');
            }

            $request = file_get_contents('php://input');
            if ($request === FALSE || empty($request)) {
                $this->_errorAndDie('Error reading POST data: ' . print_r($_SERVER, TRUE) . '/' . print_r($this->postdata, TRUE));
            }

            $merchant = isset($ipn['merchant']) ? $ipn['merchant'] : '';
            if (empty($merchant)) {
                $this->_errorAndDie('No Merchant ID passed');
            }
            if ($merchant != trim($this->merchant)) {
                $this->_errorAndDie('Invalid Merchant ID');
            }

            return TRUE;
        } else if ($ipn['ipn_mode'] == 'httpauth') {
            $merchant = isset($ipn['merchant']) ? $ipn['merchant'] : '';
            if (empty($merchant)) {
                $this->_errorAndDie('No Merchant ID passed');
            }
            if ($merchant != trim($this->merchant)){
                $this->_errorAndDie('Invalid Merchant ID');
            }
            return TRUE;
        } else {
            $this->_errorAndDie('Unknown ipn_mode.');
        }
        return FALSE;
    }

    function change_order_status($new_order_status, $comments){
        global $db;
        $sql_data_array= array(array('fieldName'=>'orders_id', 'value' => $this->order_id, 'type'=>'integer'),
            array('fieldName'=>'orders_status_id', 'value' => $new_order_status, 'type'=>'integer'),
            array('fieldName'=>'date_added', 'value' => 'now()', 'type'=>'noquotestring'),
            array('fieldName'=>'comments', 'value' => $comments, 'type'=>'string'),
            array('fieldName'=>'customer_notified', 'value' => 0, 'type'=>'integer'));
        $db->perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
        $db->Execute("update " . TABLE_ORDERS  . "
                  set orders_status = '" . (int)$new_order_status . "'
                  where orders_id = '" . (int)$this->order_id . "'");
    }

    function get_currency(){
        global $db;
        $result = $db->Execute("select * from ".TABLE_ORDERS." where orders_id=$this->order_id");
        return $result->fields['currency'];
    }

    function get_subtotal(){
        global $db;
        $result = $db->Execute("select * from ".TABLE_ORDERS." where orders_id=$this->order_id");
        return zen_round($result->fields['order_total']);
    }

    function successful_request() {
        global $order;
        $order_id = intval($this->postdata['invoice']);
        if ($this->postdata['ipn_type'] == 'button') {
            if ($this->postdata['currency'] == $this->get_currency()){
                if ($this->postdata['amount'] >= $this->get_subtotal()) {
                    $status = intval($this->postdata['status']);
                    if ($status < 0) {
                        //$order->update_status('canceled', 'order has been canceled');
                        $this->change_order_status($this->order_id, 1, 'change order to still pending');
                    } else if ($status >= 100 || $status == 2) {
                        //order complete or queued for nightly payout
                        $str = 'Payment Status: ' . $this->postdata['status_text'] . '<br />';
                        $str .= 'Transaction ID: ' . $this->postdata['txn_id'] . '<br />';
                        $str .= 'Original Amount: ' . sprintf('%.08f', $this->postdata['amount']) . '<br />';
                        $str .= 'Received Amount: ' . sprintf('%.08f', $this->postdata['amount']);
                        $this->change_order_status(2, 'change order status to processing');
                    } else {
                        $this->change_order_status(1, 'change order status to pending');
                    }
                    die('IPN OK');
                } else {
                    $this->_errorAndDie('Amount paid is less than order total!', $order);
                }
            } else {
                $this->_errorAndDie('Original currency does not match!', $order);
            }
        } else {
            $this->_errorAndDie('Invalid IPN type!', $order);
        }
    }


    function check_ipn_response() {
        if ( ! empty( $this->postdata ) && $this->check_ipn_request_is_valid($this->postdata) ) {
            $this->successful_request($this->postdata);
        } else {
            $this->_errorAndDie("request is empty or not correct");
        }
    }

}

if(isset($_POST) && !empty($_POST)){
    require('includes/application_top.php');
    require(DIR_WS_CLASSES . 'payment.php');
    $process = new Process_IPN($_POST, $debug_email, $merchant);
    $process->check_ipn_response();
}
